'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var React = require('react');
var utilsCommons = require('@highlight-ui/utils-commons');
var typography = require('@highlight-ui/typography');
var layout = require('@highlight-ui/layout');
var tooltip = require('@highlight-ui/tooltip');
var icon = require('@highlight-ui/icon');
function _interopDefaultLegacy(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    'default': e
  };
}
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
function __rest(s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}
var styles = {
  "toggleInput": "ToggleInput-module__YUzQNfq9__v0-0-31",
  "toggleInputIndicator": "ToggleInput-module__jJrIri9a__v0-0-31",
  "toggleInputLabel": "ToggleInput-module__oxSXTMro__v0-0-31",
  "toggleInputIndicatorWrapper": "ToggleInput-module__qOy8IKpm__v0-0-31",
  "toggleInputErrorTone": "ToggleInput-module__ZybhbtLC__v0-0-31",
  "tooltipContainer": "ToggleInput-module__JCMtfjcm__v0-0-31",
  "toggleInputSubLabel": "ToggleInput-module__tJExeFNO__v0-0-31",
  "toggleInputLabelText": "ToggleInput-module__ZMYr8aWg__v0-0-31"
};
var ToggleInput = React__default["default"].forwardRef(function (_a, ref) {
  var metadata = _a.metadata,
    id = _a.id,
    onClick = _a.onClick,
    onKeyUp = _a.onKeyUp,
    toggleInputProps = __rest(_a, ["metadata", "id", "onClick", "onKeyUp"]);
  return React__default["default"].createElement("input", __assign({
    id: id,
    ref: ref,
    className: styles.toggleInput,
    onClick: function (e) {
      e.stopPropagation();
      return onClick && onClick(e);
    },
    onKeyUp: function (e) {
      e.stopPropagation();
      return onKeyUp && onKeyUp(e);
    },
    "aria-describedby": "hint-" + id
  }, toggleInputProps, utilsCommons.parseMetadata(utilsCommons.suffixMetadata(metadata, 'input'))));
});
var ToggleInputLabel = function (_a) {
  var metadata = _a.metadata,
    inputId = _a.inputId,
    label = _a.label,
    disabled = _a.disabled,
    tooltipContent = _a.tooltipContent,
    tooltipMouseOutDelay = _a.tooltipMouseOutDelay,
    tone = _a.tone,
    icon$1 = _a.icon;
  return React__default["default"].createElement("label", __assign({
    htmlFor: inputId,
    className: styles.toggleInputLabel
  }, utilsCommons.parseMetadata(utilsCommons.suffixMetadata(metadata, 'label'))), React__default["default"].createElement(layout.Inline, {
    space: "spacing-0-5",
    alignVertical: "center"
  }, React__default["default"].createElement(layout.Inline, {
    space: "spacing-3",
    alignVertical: "center"
  }, React__default["default"].createElement("div", {
    className: styles.toggleInputIndicatorWrapper
  }, React__default["default"].createElement("span", {
    className: styles.toggleInputIndicator + " " + (tone === 'error' ? styles.toggleInputErrorTone : '')
  }, icon$1)), label && React__default["default"].createElement("span", {
    className: styles.toggleInputLabelText
  }, React__default["default"].createElement(typography.Body, {
    color: disabled ? 'text-disabled' : 'text-default',
    title: label,
    truncate: true
  }, label))), label && tooltipContent && React__default["default"].createElement(tooltip.Tooltip, __assign({
    content: React__default["default"].createElement(typography.Body, null, tooltipContent),
    mouseOutDelay: tooltipMouseOutDelay
  }, utilsCommons.parseMetadata(utilsCommons.suffixMetadata(metadata, 'tooltip'))), React__default["default"].createElement("span", {
    className: styles.tooltipContainer
  }, React__default["default"].createElement(icon.Icon, {
    name: "info-circle",
    color: disabled ? 'icon-disabled' : 'icon-default',
    type: "solid",
    size: 12
  })))));
};
var ToggleInputSubLabel = function (_a) {
  var inputId = _a.inputId,
    subLabel = _a.subLabel,
    disabled = _a.disabled,
    metadata = _a.metadata;
  return React__default["default"].createElement("span", {
    className: styles.toggleInputSubLabel
  }, React__default["default"].createElement(typography.Body, {
    color: disabled ? 'text-disabled' : 'text-subdued',
    title: subLabel,
    id: "hint-" + inputId,
    metadata: utilsCommons.suffixMetadata(metadata, 'sub-label')
  }, subLabel));
};
exports.ToggleInput = ToggleInput;
exports.ToggleInputLabel = ToggleInputLabel;
exports.ToggleInputSubLabel = ToggleInputSubLabel;
//# sourceMappingURL=index.js.map
